#include "interrupt.h"
//-------------------------------------------------------------------------
void intInit() {
	// ............ TIMER0 .................
	PSA = 0; 			//Prescaler Assignment bit
	T0CS = 0; 			//internal clock source
	PS0=0; 				//Prescaler is divide by 8
	PS1=1;
	PS2=0;

	// ............. TIMER2 ................
	TOUTPS0 = 0;		//	postscaler max
	TOUTPS1 = 1;
	TOUTPS2 = 0;
	TOUTPS3 = 0;
	
	T2CKPS0 = 1;		//	prescaler 1:16
	T2CKPS1 = 0;		// 	prescaler
	TMR2IE = 1;			//	tmr2 iterrupt enable
	TMR2ON = 1;			//	timer2 ON

	// ............ interrupt ..............
	T0IE = 1;	//interrupt enable
	PEIE = 1;
	GIE = 1;	//global interrupt enable
}
//-------------------------------------------------------------------------
void interrupt ISR() {
	if (T0IF && T0IE) { 
//.............. handle led matrix ........................................
		if(++led_in_sec >= 11)
			led_in_sec = 0;

		PORTB = MASQ(0, led_in_sec);
		PORTC = MASQ(1, led_in_sec);
		TRISB = ~(MASQ(2, led_in_sec));
		TRISC = ~(MASQ(3, led_in_sec));
		
		if(gameState.snd) {
			if(soundCounter++ > soundTime) {
				soundCounter = 0;
				RA2 = ~RA2;
			}
		}	
//.........................................................................
		T0IF = 0;
	} 
	
	if(TMR2IF && TMR2IE && !T0IF) {
		TMR2IF = 0;
	//.........................................................................
		
		//-------- Getting states of switches --
		//-------- handling switch S4	--------	
		if(S4) {
			keyS4counter = 0;
			keysState[STATE_S4_IDX].d = 0;
			keysState[STATE_S4_IDX].dl = 0;
		} else 
			if(keyS4counter == KEY_COUNTER_LONG)
				keysState[STATE_S4_IDX].dl = 1;
			if(keyS4counter == KEY_COUNTER)
				keysState[STATE_S4_IDX].d = 1;
			if(keyS4counter < KEY_COUNTER_LONG)
				keyS4counter++;
		//-------- handling switch S1 --------
		if(S1) {
			keyS1counter = 0;
			keysState[STATE_S1_IDX].d = 0;
			keysState[STATE_S1_IDX].dl = 0;
		} else 
			if(keyS1counter == KEY_COUNTER_LONG)
				keysState[STATE_S1_IDX].dl = 1;
			if(keyS1counter == KEY_COUNTER)
				keysState[STATE_S1_IDX].d = 1;
			if(keyS1counter < KEY_COUNTER_LONG)
				keyS1counter++;
		//-------- handling switch S2 --------
		if(S2) {
			keyS2counter = 0;
			keysState[STATE_S2_IDX].d = 0;
			keysState[STATE_S2_IDX].dl = 0;
		} else 
			if(keyS2counter == KEY_COUNTER_LONG)
				keysState[STATE_S2_IDX].dl = 1;
			else if(keyS2counter == KEY_COUNTER)
				keysState[STATE_S2_IDX].d = 1;
			if(keyS2counter < KEY_COUNTER_LONG)
				keyS2counter++;
		//------------------------------------
		if(keysState[STATE_S1_IDX].dl && keysState[STATE_S4_IDX].dl) {
			keysState[STATE_S1S4_IDX].dl = 1;
		} else {
			keysState[STATE_S1S4_IDX].dl = 0;
		}
		//------------------------------------
		if(keysState[STATE_S1_IDX].d && keysState[STATE_S4_IDX].d) {
			keysState[STATE_S1S4_IDX].d = 1;
		} else {
			keysState[STATE_S1S4_IDX].d = 0;
		}
		//------------------------------------
		if(led_blink_counter++ >= LED_BLINK_TIME) {
			led_states[LED_STATE_2] = ~led_states[LED_STATE_2];
			led_blink_counter = 0;
		}
//.........................................................................

	}
}
//-------------------------------------------------------------------------